#ifndef VS_h
#define VS_h
/*
* This is the "S" V header.  The Vflg['S'] flag  is  used  by  the
* d_sleep(n)  routine,  and  it is advised for other routines that use
* things like alarm() to cause sleeps.  The idea is to have a separate
* debug flag for operations that cause a process to go to sleep, so we
* can jack up the S debug level  to  find  out  why  a  process  isn't
* running  when  we  think it should.  Diagnosing such problems can be
* somewhat tricky...
*/
#ifndef V_h
#include "D.h"
#endif

#define V1S DD('S',1)
#define V2S DD('S',2)
#define V3S DD('S',3)
#define V4S DD('S',4)
#define V5S DD('S',5)
#define V6S DD('S',6)
#define V7S DD('S',7)
#define V8S DD('S',8)
#define V9S DD('S',9)

#define P1S DP('S',1)
#define P2S DP('S',2)
#define P3S DP('S',3)
#define P4S DP('S',4)
#define P5S DP('S',5)
#define P6S DP('S',6)
#define P7S DP('S',7)
#define P8S DP('S',8)
#define P9S DP('S',9)

#endif
