#include "D.h"

/*
* Initialize a buffer to a specific size.  We add one to the size,
* as a kludge to ensure that we can append a null byte for debug
* messages.
*/
int
initBuf(sp,bp,max)
	Srvr* sp;
	Str*  bp;
	int   max;
{	int   e=errno;
:f	Fenter("initBuf");
	++max;
:5	V5 "bp=[%lX,%d,%d,%lX]",bp->v,bp->l,bp->m,bp->p V;
	if (bp->m < max) {		/* Does this server have an input buffer yet? */
:5		V5 "Get %d bytes for %s ibuf.",max,DspSV(sp->name) V;
		e = ENOMEM;			/* Error if we can't get buffer space */
		MinStrMF(bp,max,"buffer");
	}
:5	V5 "bp=[%lX,%d,%d,%lX]",bp->v,bp->l,bp->m,bp->p V;
	bp->l = 0;
	*(bp->p = bp->v) = 0;		/* Current position in buffer */
:5	V5 "bp=[%lX,%d,%d,%lX]",bp->v,bp->l,bp->m,bp->p V;
:f	Fexit;
	return 1;
fail:
:f	Fexit;
	errno = e;
	return 0;
}
