/*
#NAME
#  Cat - distributed catenate
#
#SYNOPSIS
#  Cat [option].. [file|URL]..
#
#DESCRIPTION
#
#OPTIONS
#
#SEE ALSO
#
#BUGS
#
#AUTHOR
#  John Chambers <jc@trillian.mit.edu>
*/

#include "D.h"

char  buf[BUFSIZ];
long  bufsiz = BUFSIZ;
long  buflen = 0;
long  bytecount = 0;
int   filecount = 0;

main(ac,av)
	int   ac;
	char**av;
{	int   a, f;
	DFILE*fp;

:1	ac = Dinit(ac,av);

	for (a=1; a<ac; a++) {
		switch (av[a][0]) {
		case '+':
		case '-':
:1			V1 "Unknown option \"%s\" ignored.",av[a] V;
			continue;
		default:
			++filecount;
			if ((f = Open(av[a],0,0)) < 0) {
				exitstat = errno;
:2				V2 "File %d is \"%s\"",f,av[a] V;
				continue;
			}
:2			V2 "File %d is \"%s\"",f,av[a] V;
			while ((buflen = Read(f,buf,bufsiz)) > 0) {
:5				V5 "Got %s",Dspp(buf) V;
				Write(0,buf,buflen);
				bytecount += buflen;
			}
			if (buflen < 0) {
				exitstat = errno;
:1				V1 "Can't read file %d \"%s\" [Err %d=%s=%s]",f,av[a],Errinfo V;
			}
			Close(f);
		}
	}
	if (filecount < 1) {
		while ((buflen = Read(0,buf,bufsiz)) > 0) {
:5			V5 "Got %s",Dspp(buf) V;
			Write(0,buf,buflen);
			bytecount += buflen;
		}
		if (buflen < 0) {
			exitstat = errno;
:1			V1 "Can't read stdin file %d \"%s\" [Err %d=%s=%s]",0,av[a],Errinfo V;
		}
	}
:2	V2 "%10d files copied.",filecount V;
:2	V2 "%10d bytes copied.",bytecount V;

:2	V2 "Exit status %d.",exitstat V;
	Exit(exitstat);
}
