:i	static char Vtest_sccs_id[] = "%W% %G%";
:1#include "D.h"
#include "mem.h"
#include "sys_varargs.h"
/*
* Here's a simple test routine, which will accept a  -d<l><file>  arg,
* and  put  out sample debug messages for each level from 0 to 9.  You
* might test it by compiling with -DTEST and -DDEBUG=5 or a few  other
* values, and see if the DEBUG level properly suppresses the output.
*/
extern char * ttyname();
global int   i1, i2;
global ulong u1, u2;
global float f1, f2;
int
main(ac,av)
	char**av;
{	int   a;
:8	int   f;
	char *p;

:9	printf("Start ...\n");
:9	fflush(stdout);
:9	printf("Start \"%s\" Vlvl=%d ...\n",av[0],Vlvl);
:9	fflush(stdout);
:9	printf("stdout=%lX stderr=%lX Vout=%lX _iob=%lX.\n",stdout,stderr,Vout,_iob);
:9	fflush(stdout);
	errno = 0;
:9	Vlvl = 9;
	Vfshow = 3;
:9	printf("Start \"%s\" Vlvl=%d ...\n",av[0],Vlvl);
:9	fflush(stdout);
:9	for (f=0; f<4; f++) {
:9		if (isatty(f)) {
:9			p = ttyname(f);
:9			printf("File %d is tty \"%s\"\n",f,p?p:"[unknown]");
:9		} else {
:9			printf("File %d is not a tty.\n",f);
:9		}
:9	}
:7	V1 "This message should not appear." V;
:7	V2 "This message should also not appear." V;
:1	ac = Dinit(ac,av);
:9	printf("stdout=%lX stderr=%lX Vout=%lX _iob=%lX after Dinit.\n",stdout,stderr,Vout,_iob);
:9	fflush(stdout);
:2	V2 "There are %d args, and USE_varargs=%d.",ac,USE_varargs V;
:9	for (f=0; f<4; f++) {
:9		if (isatty(f)) {
:9			p = ttyname(f);
:9			printf("File %d is tty \"%s\"\n",f,p?p:"[unknown]");
:9		} else {
:9			printf("File %d is not a tty.\n",f);
:9		}
:9	}
	for (a=1; a<ac; a++) {
:1		V2 "Arg%3d=%s",a,Dsps(av[a],-1) V;
		if (av[a][0] == '-') {
:1			V2 "Option \"%s\"",av[a] V;
			Switch(av[a][1]) {
:1			  case 'D':
:1			  case 'd':
:1				Vopt(av[a]+2);
:1				V2 "Debug level %d file %s",Vlvl,Dsps(Vfile,-1) V;
:1				break;
		      default:
:1				V1 "Option \"%s\" unknown, ignored.",av[a] V;
				break;
			}
		} else {
:1			V1 "Arg%3d=\"%s\" unknown, ignored.",a,av[a] V;
			break;
		}
	}
	i1 = 17;
	i2 = -17;
	u1 = 0xF;
	u2 = 0xFFFFFFFF;
	f1 = 1.1;
	f2 = -17.42;
/*
* The P*() messages should appear without any initial junk added, only
* a newline appended.  They are all indented via a single tab, so they
* should stand out.
*/
:0	P0 "==============================================" V;
:0	P0 "First, 'P' messages 0-%d:",Vlvl V;
:0	P0 "\tMessage P0" V;
	p1();
/*
* Let's see if the Vopt(0L) call works:
*/
:0	P0 "Next, use Vopt(0L) to reopen the Vout file:" V;
	Vopt(0L);
/*
* The D*() messages should have the last 2 (or 3 depending on jc_Vd)
* functions*  from the stack at the left, plus a tab, the message, and
  a newline.
*/
:0	P0 "Next, 'D' messages 0-%d:",Vlvl V;
:0	V0 "Message V0" V;
:1	d1();
/*
* Here's a special goodie to test the  'M'  debug  flag.   The  memory
* routines have messages showing the calls at level 6M and more detail
* at higher levels of Vflg['M'].
*/
:0	P0 "Last, 'M' messages 0-%d:",Vflg['M'] V;
	p = (CP)GetChunk(100,"GetChunk");
	p = (CP)SizChunk(p,100,200,"SizChunk");
	IRelChunk(p,"IRelChunk");

:0	P4 "Here is the open-file table:" V;
	if (Vlvl>=4) Vdmpft();

:1	V1 "%s	All done.",Vtime() V;
	exit(errno);
}
/*
* Here are some "debug" output routines.  The result should  be  a  series  of
* output  lines  labeled  "Message  V0"  thru  "Message V9", but ending at the
* current debug level. These routines should also produce one or more function
* names at the start of each line of output; the number of functions displayed
* is determined in jc_Vd().
*/
d1()
{
:f	Fenter("d1");
:2	if (Vlvl > 4) ChkFlvl;
:1	V1 "Message V1 i1=%d	[should be 17]"  ,i1 V;
:2	V2 "Message V2 i2=%d	[should be -17]" ,i2 V;
:3	d3();
:f	Fexit;
	return(1);
}
d3()
{
:f	Fenter("d3");
:2	if (Vlvl > 4) ChkFlvl;
:3	V3 "Message V3 u1=%u	[should be 15 in %s]"        ,u1,Fctname V;
:4	V4 "Message V4 u2=%lu	[should be 4294967295]",u2 V;
#if VBS_SLOW
:5	H5(&Vfct,sizeof(V_f),"V_f");
#endif /*VBS_SLOW*/
	d5();
:f	Fexit;
	return(3);
}
d5()
{
:f	Fenter("d5");
:2	if (Vlvl > 4) ChkFlvl;
:5	V5 "Message V5 f1=%.3f	[should be 1.100]"     ,f1 V;
:6	V6 "Message V6 f2=%.3f	[should be -17.420]"   ,f2 V;
:8	if (Vlvl>4)
:8		V8 "fprintf V5 f1=%.3f	[should be 1.100]\n"  ,f1 V;
:8	if (Vlvl>4)
:8		V8 "fprintf V6 f2=%.3f	[should be -17.420]\n",f2 V;
:5	if (Vlvl>4)
:5		stktst();
	d7();
:f	Fexit;
	return(5);
}
d7()
{
:f	Fenter("d7");
:7	V7 "Message V7 i1=%d i2=%d u1=%u u2=%u f1=%f f2=%f",i1,i2,u1,u2,f1,f2 V;
:8	V8 "Message V8 [in %s]",Fctname V;
:f	Fexit;
	return(7);
}
d9()
{
:f	Fenter("d9");
:9	V9 "Message V9 [in %s]",Fctname V;
:f	Fexit;
	return(9);
}
/*
* Here are some similar "print" routines, which should produce pretty much the
* same output as the above d*() routines, but without any junk at the start of
* the output lines.
*/
p1()
{
:f	Fenter("p1");
:1	P1 "\tMessage P1 i1=%d	[should be 17]"        ,i1 V;
:2	P2 "\tMessage P2 i2=%d	[should be -17]"       ,i2 V;
:9	printf("Before p3()\n");
:3	p3();
:9	printf("After  p3()\n");
:f	Fexit;
	return(1);
}
p3()
{
:f	Fenter("p3");
:9	printf("Enter  p3()\n");
:9	printf("\tMessage P3\n");
:9	printf("\tMessage P3 u1=%lu\n",u1);
:9	printf("\tMessage P3 u1=%lu	[should be 15 in %08X]\n",u1,Fctname);
:9	printf("\tMessage P3 u1=%lu	[should be 15 in %s]\n"  ,u1,Fctname);
:3	P3 "\tMessage P3 u1=%lu"        ,u1 V;
:9	P3 "\tMessage P3 u1=%lu	[should be 15 in %08X]"  ,u1,Fctname V;
:3	P3 "\tMessage P3 Fctname is \"%s\"",Fctname V;
:3	P3 "\tMessage P3 u1=%lu	[should be 15 in %s]"    ,u1,Fctname V;
:4	P4 "\tMessage P4 u2=%u	[should be 4294967295]",u2 V;
	p5();
:f	Fexit;
:9	printf("Exit   p3()\n");
	return(3);
}
p5()
{
:f	Fenter("p5");
:5	P5 "\tMessage P5 f1=%.3f	[should be 1.100]"     ,f1 V;
:6	P6 "\tMessage P6 f2=%.3f	[should be -17.420]"   ,f2 V;
	p7();
:f	Fexit;
	return(5);
}
p7()
{
:f	Fenter("p7");
:7	P7 "\tMessage P7 i1=%d i2=%d u1=%u u2=%u f1=%f f2=%f",i1,i2,u1,u2,f1,f2 V;
:8	P8 "\tMessage P8 [in %s]",Fctname V;
:f	Fexit;
	return(7);
}
p9()
{
:f	Fenter("p9");
:9	P9 "\tMessage P9 [in %s]",Fctname V;
:f	Fexit;
	return(9);
}
/*
* Here is a routine for exercising the stack-checking macro.  We call badstk()
* to push its struct on the stack and not pop it; the V_Flvl macro should then
* give us an error message.  We then pop the stack, and all should be OK.
*/
stktst()
{
:f	Fenter("stktst");
#if VBS_SLOW
:2	V2 "Checking debug stack control ..." V;
:2	ChkFlvlM("Should be good");
:2	V2 "Call badstk() ..." V;
	badstk();
:2	ChkFlvlM("Should be bad");
	Vfcts = &Vfct;		/* Here is how to restore the Vfct stack */
	Vflvl = flevel;
:2	ChkFlvlM("Should be good but isn't");	/* No message if OK */
:2	V2 "-- Only two warning messages should preceed this line." V;
#endif /*VBS_SLOW*/
:f	Fexit;
	return(0);
}
badstk()
{
:f	Fenter("badstk");
:2	if (Vlvl > 4) ChkFlvl;
:2	ChkFlvl;
:2	V2 "--- A warning should follow about a bad stack:" V;
/*	*** No Fexit here!!! */
	return(0);
}
