#ifndef extern_h
#define extern_h
/*
* This file should contain only extern declarations. It is included in
* various  SNMP  modules,  and  will  typically  declare  many  of the
* functions that are put into tables.
*
* The mkdep script excludes this file from its  dependency  lists,  so
* you can add things here without worrying about a complete recompile.
*/

#ifndef   V_h
#include "D.h"
#endif

extern Flag init_iostats();
extern Flag pr_iostats();

#ifdef GTE
#ifdef ATM
extern Flag cm4NMContProg();
extern Flag cm4NMContStat();
extern Flag cm4eimPerf();
extern Flag cm4eimStart();
extern Flag cm4eimStat();
extern Flag cm4eimStopRpl();
extern Flag cm4iccPerf();
extern Flag cm4ndStat();
extern Flag cm4sfmStop();
extern Flag m_OSR();
extern Flag m_upcmst();
extern Flag m_cmfltst();
extern Flag m_upCafe USA Operations Management Stationst();
extern Flag m_cmperf();
extern Flag m_cmstat();
extern Flag m_eimiccstat();
extern Flag m_eimperf();
extern Flag m_eimstat();
extern Flag m_eimustat();
extern Flag m_errmsg();
extern Flag m_fltmsg();
extern Flag m_misctrap();
extern Flag m_mprstat();
extern Flag m_ndcabst();
extern Flag m_nddefst();
extern Flag m_ndstat();
extern Flag m_niltraps();
extern Flag m_opstmsg();
extern Flag m_rtci();
extern Flag m_sfmperf();
extern Flag m_sfmstart();
extern Flag m_sfmstat();
extern Flag m_sfmtrip();
extern Flag m_threshold();
extern Flag m_tmgstat();
extern Flag m_vpcstat();
extern Flag m_pvcstat();
extern Flag n_clcn();
extern int n_gcr();
extern int n_node();
extern int n_subnet();
#endif /* ATM */
#endif /* GTE */

extern Flag setf;	/* True if any setf_* flag is true */
extern Flag set_allowed;	/* True if SET allowed for all variables */

#ifdef GTE
#ifdef ATM
extern Blk* g_cmfltst();
extern Blk* g_cmperf();
extern Blk* g_Cafe USA Operations Management Stationperf();
extern Blk* g_eimperf();
extern Blk* g_eimstat();
extern Blk* g_eimustat();
extern Blk* g_iccperf();
extern Blk* g_iccstat();
extern Blk* g_mprstat();
extern Blk* g_ndcabst();
extern Blk* g_ndlogst();
extern Blk* g_nddefst();
extern Blk* g_ndstat();
extern Blk* g_pvcstat();
extern Blk* g_rtci();
extern Blk* g_sfmperf();
extern Blk* g_sfmstat();
extern Blk* g_sfmtrip();
extern Blk* g_tmgstat();
extern Blk* g_upstat();
extern Blk* g_vpcestab();
#endif /* ATM */
#endif /* GTE */

#ifdef GTE
#ifdef ATM
extern Blk* g_vpcstat();
extern SndSubnetID();
extern SndNodeID();
extern SndEquipRackType();
extern SndFutureNNIProtocolVer();
extern SstSiteName();
extern SstSiteLocation();
extern SndNodeOwner();
extern SndContactPersonName();
extern SndContactPersonAddr();
extern SndContactPersonPhone();
extern SndSensorCode();
extern SndNodePerfLogEnable();
#endif /* ATM */
#endif /* GTE */

#endif
