:i	static char str_zapsm_sccs_id[] = "%W% %G%";
#include "D_M.h"
#include "str.h"
#include "mem.h"

/*
* Get rid of a Str's value, giving a null string. We can only free it,
* of  course,  if the m field is nonzero.  We zero out all the fields,
* giving a null string descriptor.  The string descriptor is returned,
* though most callers don't care.
*/
Str * str_zapsm(dst,msg)
	Str *dst;
	char*msg;
{
:f	Fenter("str_zapsm");
	if (!dst) Fail;
:2	if (!msg) msg = unknown;
:7	V7M "Zap %s string at %08X, v=%08X",msg,dst,dst->v V;
	if (dst->m && dst->v) {	/* Some paranoia here */
:7		V6M "Free %s v at %08X",msg,dst->v V;
		RelChunk(dst->v,msg);
	}
	dst->l = dst->m = 0;
	dst->p = dst->v = 0;
fail:
:f	Fexit;
	return dst;
}
