#ifndef sys_malloc_h
/*
* The type returned by malloc() is one of  the  worst  cases  for  the
* strong-typing  ideology,  and  of  course  the  various vendors have
* screwed it up in all sorts of clever and entertaining ways.   We  do
* what we can to make sense of it all.
*/

#if defined(LINUX) || defined(ESIX4)
#include <malloc.h>
#define sys_malloc_h
#endif

#if defined(SUN) || defined(AIX) || defined(OSF1)
#include <malloc.h>
#define sys_malloc_h
#endif

#ifndef sys_malloc_h
extern char* malloc();	/* (char*) or (void*) is probably best */
#define sys_malloc_h
#endif

#endif
