#ifndef sys_tcp_h
/*
* This header file must find the definition of the kernel's in_pcb struct,
* and anything related to that struct that our code needs.
*/

#ifndef   sys_socket_h
#include "sys_socket.h"
#endif

#if !defined(sys_tcp_h) && defined(SUN)
static char scnfpsys_tcp_h[] = "SUN";
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#define sys_tcp_h
#endif

#if !defined(sys_tcp_h) && defined(OSF1)
static char scnfpsys_tcp_h[] = "OSF1";
#include <sys/timers.h>
#include <netinet/tcp.h>
#define sys_tcp_h
#endif

#endif
